;******************************************************************************
;    Filename: LCD_SyncEeprom.Asm                                                   *
;    Date:                                                                    *
;    File Version: 000.001                                                    *
;    Author: PSW.RU                                                           *
;    Company: Labs                                                            *
;******************************************************************************
;                                                                             *
;    Files required:         P18F4431.INC, Pic18_M.INC,LCD_Text.asm           *
;                                                                             *
;******************************************************************************
	#include Define.inc	;     
;*******************************
;    -   
;*******************************
 #ifdef	EPROM_Present

;#define ParametrStor	d'7'	;    
;#define FsrLoadParam	lfsr	0,Par_T1	; -0  
;          
;   .     
;  ,   -     

; ,  / ,   .
;    ,     
;  -    ,  ,   
;   .
;  -    ,  ,   ,
;      .
;          .
;       -  .
;     1       ,
;  ""     1    2  
;   "  "  =0 (  ),
;  "Bad Block"  .

	global	EPROM_Sync,EPROM_Read;,EPROM_Table;,ParametrStor
EPROM_Sync	code
	Extern	InitAll
	;      NOP
	goto	InitAll	;       - 
EPROM_Table
 #include Proj_Dir\EPROM\EPROM_RegsAdr.inc	;      
EPROM_Sync
	EPROM_Page ; BSR for EPROM Task
	BTFSC EECON1, WR ; Wait for write to complete
 return	;    -  

	BCF EECON1, WREN,ACCESS	; Disable writes - all time
	BCF PIR2, EEIF,ACCESS 	; Clear interrupt flag

	btfsc	LCD_Flg1,1,ACCESS	;   ?
		bra	Ee_Done1			;  

	clrf CountSyn,BANKED;           
;   

	movlf	 low(EPROM_Table),TblPtrBuf+0,BANKED;TBLPTRL,ACCESS;   
	movlf	high(EPROM_Table),TblPtrBuf+1,BANKED;TBLPTRH,ACCESS;    
;	clrf	TBLPTRU,ACCESS		;<64 kB     

	bsf		LCD_Flg1,1,ACCESS	;    
Ee_Done1	;       

	BCF EECON1, CFGS,ACCESS		; Point to memory
	clrf	TBLPTRU,ACCESS		;<64 kB     
  movff_N	 TblPtrBuf,TBLPTRL,2;<64 kB;     

	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory
SkipDummyBadBlock
	tblrd*+	;    
	movff	TABLAT,FSR0L	;   

	tblrd*+	;      
	movff	TABLAT,FSR0H	;   

  movff_N	 TBLPTRL,TblPtrBuf,2;<64 kB;      
;     

;         -     "-"
; 	
	tstfsz	FSR0H,ACCESS	; "BAD Block" dummy address
		bra Ee_Done2
	tstfsz	FSR0L,ACCESS	;   
		bra Ee_Done2
;
	bra SkipDummyBadBlock	;      -
 return	;   "-"     

Ee_Done2

 bcf	INTCON,GIEL,ACCESS	;    
;    EECON1         

	BCF EECON1, EEPGD,ACCESS	; Point to DATA memory	
	
	MOVFF CountSyn,EEADR ; Data Memory Address to read
	BSF EECON1, RD,ACCESS		 ; EEPROM Read

	movf	INDF0,W,ACCESS	;     

	cpfseq	EEDATA,ACCESS		;     
		rcall	Ee_Write		;    

	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory -   
 bsf	INTCON,GIEL,ACCESS	;    

	incf	CountSyn,F,BANKED		;   
	movlw	(EPROM_Sync-EPROM_Table)/2;   
	cpfslt	CountSyn,BANKED		;    
  bra EndSyncEprom
; 		return 
 return	; /   1       

EndSyncEprom
	bcf		LCD_Flg1,0,ACCESS	;  
	bcf		LCD_Flg1,1,ACCESS	;    
 return

Ee_Write;    
	movwf	EEDATA,ACCESS		;          
	incf	EpromWriteCount,F,ACCESS	;
	;BCF EECON1, EEPGD ; Point to DATA memory
	BSF EECON1, WREN,ACCESS; Enable writes
	BCF INTCON, GIE,ACCESS; Disable Interrupts
		MOVLW 0x55 ;
		MOVWF EECON2,ACCESS ; Write 55h
		MOVLW 0xAA ;
		MOVWF EECON2,ACCESS ; Write AAh
	BSF EECON1, WR,ACCESS ; Set WR bit to begin write
	BCF EECON1, WREN,ACCESS ; Disable writes - not affect for begin write
	BSF INTCON, GIE,ACCESS ; Enable Interrupts
 return

EPROM_Read	;         

;       
	EPROM_Page ; BSR for EPROM Task
	clrf CountSyn,BANKED;      
	BCF EECON1, CFGS,ACCESS ; Point to memory	

;	movlf	low(EPROM_Table),TblPtrBuf,BANKED;TBLPTRL,ACCESS;   
;	movlf	high(EPROM_Table),TblPtrBuf+1,BANKED;TBLPTRH,ACCESS;    

	movlf	low(EPROM_Table),TBLPTRL,ACCESS;   
	movlf	high(EPROM_Table),TBLPTRH,ACCESS;    

	clrf	TBLPTRU,ACCESS		;<64 kB 
;  movff_N	 TBLPTRL,TblPtrBuf,2;<64 kB;     
	
LoopReadEprom
;  movff_N	 TblPtrBuf,TBLPTRL,2;<64 kB;     

	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory

	tblrd*+	;    
	movff	TABLAT,FSR0L	;   

	tblrd*+	;      
	movff	TABLAT,FSR0H	;   

;  movff_N	 TBLPTRL,TblPtrBuf,2;<64 kB;      
;     

	BCF EECON1, EEPGD,ACCESS ; Point to DATA memory
	MOVFF CountSyn,EEADR ; Data Memory Address to read
	BSF EECON1, RD,ACCESS ; EEPROM Read
	nop	; EPROM DATA Valid
	
;	movff	EEDATA,INDF0	;      
	movf	EEDATA,W,ACCESS
	movwf	INDF0,ACCESS	;      

	incf	CountSyn,F,BANKED		;   
	movlw	(EPROM_Sync-EPROM_Table)/2;ParametrStor	;   
	cpfslt	CountSyn,BANKED		;    
 		return 
  bra LoopReadEprom

;*******************************
;    -   
;*******************************
 #endif	;#ifdef	EPROM_Present
;End of program

		END
